//+------------------------------------------------------------------+
//|                                            ccitema.mq5           |
//|                                 Copyright 2012,Iwan Whiteley     |
//|                              http://www.daytradersjournal.com    |
//+------------------------------------------------------------------+
#property copyright "2012, Iwan Whiteley"
#property link      "http://www.daytradersjournal.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_plots   1

#include <MovingAverages.mqh>

//---- plot Label1
#property indicator_label1  "CCI TEMA"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrDarkTurquoise
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

#property indicator_level1       -100.0
#property indicator_level2        100.0

input int period1=10; //cci period1

//--- indicator buffers
double         buffer1[];
double         buffer2[];
double         buffer3[];
double         buffer4[];
double         buffer5[];
double         buffer6[];
double         buffer7[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
SetIndexBuffer(0,buffer2,INDICATOR_DATA);
SetIndexBuffer(1,buffer1,INDICATOR_CALCULATIONS);
SetIndexBuffer(2,buffer3,INDICATOR_CALCULATIONS);
SetIndexBuffer(3,buffer4,INDICATOR_CALCULATIONS);
SetIndexBuffer(4,buffer5,INDICATOR_CALCULATIONS);
SetIndexBuffer(5,buffer6,INDICATOR_CALCULATIONS);
SetIndexBuffer(6,buffer7,INDICATOR_CALCULATIONS);
   
IndicatorSetInteger(INDICATOR_DIGITS,2);
IndicatorSetString(INDICATOR_SHORTNAME,"cci-tema ("+(string)period1+")");

   ResetLastError();

//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
  
int i=0, limit;

//--- check for bars count
   if(rates_total<2*period1)
      return(0);
     
     if(prev_calculated==0)
     {
     
     limit = 2*period1; 
    
     }
   else limit=prev_calculated-1;
   
   ExponentialMAOnBuffer(rates_total,prev_calculated,0,period1,close,buffer4);
   ExponentialMAOnBuffer(rates_total,prev_calculated,period1-1,period1,buffer4,buffer5);
   ExponentialMAOnBuffer(rates_total,prev_calculated,2*period1-2,period1,buffer5,buffer6);

 for(i=limit;i<rates_total && !IsStopped();i++)
     {

   double meandev=0.0;
   double sumdev=0.0;
   
   buffer7[i] = 3*buffer4[i]-3*buffer5[i]+buffer6[i];
   //--- CCI-LWMA
   buffer1[i] = close[i] - buffer7[i];
   
   for(int k=0;k<period1;k++)
   {
   
   sumdev += MathAbs(buffer1[i-k]);
   
   }
   
   meandev = sumdev/period1;
   
   //cci
   buffer2[i] = buffer1[i]/(0.015*meandev);

                     } 
   return(rates_total);
  }
//+------------------------------------------------------------------+